// ==============================================================
// File generated by Xilinx Model Composer(TM)
// Version: 2020.2
//  
// (c) Copyright 2017 - 2020 Xilinx, Inc. All rights reserved.
//  
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
//  
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
//  
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
//  
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.
// ==============================================================
#include "XMC_dq_current_ctrl.h"
#include <ap_shift_reg.h>
#include <xmcArithBasics.h>
#include <xmcArithDivide.h>
#include <xmcArithSatBasics.h>
#include <StreamAdapters.h>
void
XMC_dq_current_ctrl_core(float Ig_d_ref, float Ig_q_ref, float Ig_d, float Ig_q
    , float Ug_d, float Ug_q, float kp_dq, float kiTs_dq, float* Eg_d_ref, 
    float* Eg_q_ref, float* Eg_zero_ref)
{
    #pragma HLS inline
    float Gain_out1;
    float Gain1_out1;
    float Subtract_out1;
    float Subtract1_out1;
    float Delay_out1;
    float Delay_out1_0;
    float Product_out1;
    float Product1_out1;
    uint32_t Reinterpret_out1;
    float Product_out1_0;
    float Product1_out1_0;
    uint32_t Reinterpret_out1_0;
    uint32_t Reinterpret1_out1;
    uint32_t Reinterpret1_out1_0;
    float MAX_out1;
    float MAX_out1_0;
    float MIN_out1;
    float Constant_out1;
    float MIN_out1_0;
    float Constant_out1_0;
    float Sum_out1;
    ap_ufixed<1,1,AP_TRN,AP_WRAP,0> Bit_Slice_out1;
    float Sum_out1_0;
    ap_ufixed<1,1,AP_TRN,AP_WRAP,0> Bit_Slice_out1_0;
    ap_ufixed<1,1,AP_TRN,AP_WRAP,0> Bit_Slice1_out1;
    ap_ufixed<1,1,AP_TRN,AP_WRAP,0> Bit_Slice1_out1_0;
    bool Greater_out1;
    bool Greater_out1_0;
    bool Equals_out1;
    bool Equals_out1_0;
    bool Conditional_cmp_out;
    bool Conditional_cmp_out_0;
    float Conditional_out1;
    float Conditional_out1_0;
    bool Lesser_out1;
    bool Lesser_out1_0;
    bool Bitwise_OR_out1;
    bool Conditional1_cmp_out;
    bool Bitwise_OR_out1_0;
    bool Conditional1_cmp_out_0;
    bool Unit_Delay_out1;
    float Conditional1_out1;
    bool Unit_Delay_out1_0;
    float Conditional1_out1_0;
    bool Bitwise_AND2_out1;
    float Subtract2_out1;
    bool Bitwise_AND2_out1_0;
    float Sum2_out1;
    bool Conditional_cmp_out_1;
    bool Conditional_cmp_out_2;
    float Conditional_out1_1;
    float Conditional_out1_2;
    float Sum1_out1;
    float Sum1_out1_0;
    bool Conditional1_thr_out = false;
    float MAX_c = 5.000000000e+02f;
    float MAX_c_0 = 5.000000000e+02f;
    float Constant_c = 0.000000000e+00f;
    float MIN_c = -5.000000000e+02f;
    bool Conditional_thr_out = false;
    float Constant_c_0 = 0.000000000e+00f;
    bool Conditional_thr_out_0 = false;
    bool Conditional1_thr_out_0 = false;
    float MIN_c_0 = -5.000000000e+02f;
    bool Conditional_thr_out_1 = false;
    float Constant_c_1 = 0.000000000e+00f;
    bool Conditional_thr_out_2 = false;
    static ap_shift_reg<float, 1> Delay_q;
    #pragma HLS reset variable=Delay_q
    static ap_shift_reg<float, 1> Delay_q_0;
    #pragma HLS reset variable=Delay_q_0
    float Gain_const = 7.853981853e-01f;
    xmc::arith::convert(Gain_out1, xmc::arith::mul< float >(Ig_q, Gain_const));
    float Gain1_const = 7.853981853e-01f;
    xmc::arith::convert(Gain1_out1, xmc::arith::mul< float >(Ig_d, Gain1_const)
        );
    xmc::arith::sub(Subtract_out1, Ig_d_ref, Ig_d);
    xmc::arith::sub(Subtract1_out1, Ig_q_ref, Ig_q);
    static uint32_t Delay_init_count_down = 1u;
    #pragma HLS reset variable=Delay_init_count_down
    float Delay_tmp(0);
    if (!Delay_init_count_down) {
        Delay_tmp = Delay_q.read();
    }
    Delay_out1 = Delay_tmp;
    if (Delay_init_count_down) {
        --Delay_init_count_down;
    }
    static uint32_t Delay_init_count_down_0 = 1u;
    #pragma HLS reset variable=Delay_init_count_down_0
    float Delay_tmp_0(0);
    if (!Delay_init_count_down_0) {
        Delay_tmp_0 = Delay_q_0.read();
    }
    Delay_out1_0 = Delay_tmp_0;
    if (Delay_init_count_down_0) {
        --Delay_init_count_down_0;
    }
    xmc::arith::mul(Product_out1, Subtract_out1, kp_dq);
    xmc::arith::mul(Product1_out1, Subtract_out1, kiTs_dq);
    Reinterpret_out1 = *reinterpret_cast< uint32_t* >(&Subtract_out1);
    xmc::arith::mul(Product_out1_0, Subtract1_out1, kp_dq);
    xmc::arith::mul(Product1_out1_0, Subtract1_out1, kiTs_dq);
    Reinterpret_out1_0 = *reinterpret_cast< uint32_t* >(&Subtract1_out1);
    Reinterpret1_out1 = *reinterpret_cast< uint32_t* >(&Delay_out1);
    Reinterpret1_out1_0 = *reinterpret_cast< uint32_t* >(&Delay_out1_0);
    MAX_out1 = MAX_c;
    MAX_out1_0 = MAX_c_0;
    *Eg_zero_ref = Constant_c;
    MIN_out1 = MIN_c;
    Constant_out1 = Constant_c_0;
    MIN_out1_0 = MIN_c_0;
    Constant_out1_0 = Constant_c_1;
    xmc::arith::add(Sum_out1, Product_out1, Delay_out1);
    ap_ufixed<32,32,AP_TRN,AP_WRAP,0> Bit_Slice_out_temp;
    Bit_Slice_out_temp = Reinterpret_out1;
    Bit_Slice_out1 = Bit_Slice_out_temp.range(31, 31);
    xmc::arith::add(Sum_out1_0, Product_out1_0, Delay_out1_0);
    ap_ufixed<32,32,AP_TRN,AP_WRAP,0> Bit_Slice_out_temp_0;
    Bit_Slice_out_temp_0 = Reinterpret_out1_0;
    Bit_Slice_out1_0 = Bit_Slice_out_temp_0.range(31, 31);
    ap_ufixed<32,32,AP_TRN,AP_WRAP,0> Bit_Slice1_out_temp;
    Bit_Slice1_out_temp = Reinterpret1_out1;
    Bit_Slice1_out1 = Bit_Slice1_out_temp.range(31, 31);
    ap_ufixed<32,32,AP_TRN,AP_WRAP,0> Bit_Slice1_out_temp_0;
    Bit_Slice1_out_temp_0 = Reinterpret1_out1_0;
    Bit_Slice1_out1_0 = Bit_Slice1_out_temp_0.range(31, 31);
    Greater_out1 = Sum_out1 > MAX_out1;
    Greater_out1_0 = Sum_out1_0 > MAX_out1_0;
    Equals_out1 = Bit_Slice_out1 == Bit_Slice1_out1;
    Equals_out1_0 = Bit_Slice_out1_0 == Bit_Slice1_out1_0;
    Conditional_cmp_out = Greater_out1 != Conditional_thr_out_0;
    Conditional_cmp_out_0 = Greater_out1_0 != Conditional_thr_out_2;
    Conditional_out1 = Conditional_cmp_out ? MAX_out1 : Sum_out1;
    Conditional_out1_0 = Conditional_cmp_out_0 ? MAX_out1_0 : Sum_out1_0;
    Lesser_out1 = Conditional_out1 < MIN_out1;
    Lesser_out1_0 = Conditional_out1_0 < MIN_out1_0;
    Bitwise_OR_out1 = Lesser_out1 | Greater_out1;
    Conditional1_cmp_out = Lesser_out1 != Conditional1_thr_out_0;
    Bitwise_OR_out1_0 = Lesser_out1_0 | Greater_out1_0;
    Conditional1_cmp_out_0 = Lesser_out1_0 != Conditional1_thr_out;
    static bool Unit_Delay_q = false;
    #pragma HLS reset variable=Unit_Delay_q
    Unit_Delay_out1 = Unit_Delay_q;
    Unit_Delay_q = Bitwise_OR_out1;
    Conditional1_out1 = Conditional1_cmp_out ? MIN_out1 : Conditional_out1;
    static bool Unit_Delay_q_0 = false;
    #pragma HLS reset variable=Unit_Delay_q_0
    Unit_Delay_out1_0 = Unit_Delay_q_0;
    Unit_Delay_q_0 = Bitwise_OR_out1_0;
    Conditional1_out1_0 = Conditional1_cmp_out_0 ? MIN_out1_0 : 
        Conditional_out1_0;
    Bitwise_AND2_out1 = Equals_out1 & Unit_Delay_out1;
    xmc::arith::sub(Subtract2_out1, Conditional1_out1, Gain_out1);
    Bitwise_AND2_out1_0 = Equals_out1_0 & Unit_Delay_out1_0;
    xmc::arith::add(Sum2_out1, Gain1_out1, Conditional1_out1_0);
    Conditional_cmp_out_1 = Bitwise_AND2_out1 != Conditional_thr_out;
    xmc::arith::add(*Eg_d_ref, Subtract2_out1, Ug_d);
    Conditional_cmp_out_2 = Bitwise_AND2_out1_0 != Conditional_thr_out_1;
    xmc::arith::add(*Eg_q_ref, Ug_q, Sum2_out1);
    Conditional_out1_1 = Conditional_cmp_out_1 ? Constant_out1 : Product1_out1;
    Conditional_out1_2 = Conditional_cmp_out_2 ? Constant_out1_0 : 
        Product1_out1_0;
    xmc::arith::add(Sum1_out1, Conditional_out1_1, Delay_out1);
    xmc::arith::add(Sum1_out1_0, Conditional_out1_2, Delay_out1_0);
    Delay_q.shift(Sum1_out1, 0);
    Delay_q_0.shift(Sum1_out1_0, 0);
}

/**
 * @brief XMC_dq_current_ctrl
 * @param Ig_d_ref direction=input protocol=AXI4-Stream length=1
 * @param Ig_q_ref direction=input protocol=AXI4-Stream length=1
 * @param Ig_d direction=input protocol=AXI4-Stream length=1
 * @param Ig_q direction=input protocol=AXI4-Stream length=1
 * @param Ug_d direction=input protocol=AXI4-Stream length=1
 * @param Ug_q direction=input protocol=AXI4-Stream length=1
 * @param kp_dq direction=input protocol=AXI4-Stream length=1
 * @param kiTs_dq direction=input protocol=AXI4-Stream length=1
 * @param Eg_d_ref direction=output protocol=AXI4-Stream length=1
 * @param Eg_q_ref direction=output protocol=AXI4-Stream length=1
 * @param Eg_zero_ref direction=output protocol=AXI4-Stream length=1
 */
void
XMC_dq_current_ctrl(hls::stream< float >& Ig_d_ref, hls::stream< float >& 
    Ig_q_ref, hls::stream< float >& Ig_d, hls::stream< float >& Ig_q, 
    hls::stream< float >& Ug_d, hls::stream< float >& Ug_q, 
    hls::stream< float >& kp_dq, hls::stream< float >& kiTs_dq, 
    hls::stream< float >& Eg_d_ref, hls::stream< float >& Eg_q_ref, 
    hls::stream< float >& Eg_zero_ref)
{
    #pragma HLS INTERFACE axis port=Ig_d_ref
    #pragma HLS INTERFACE axis port=Ig_q_ref
    #pragma HLS INTERFACE axis port=Ig_d
    #pragma HLS INTERFACE axis port=Ig_q
    #pragma HLS INTERFACE axis port=Ug_d
    #pragma HLS INTERFACE axis port=Ug_q
    #pragma HLS INTERFACE axis port=kp_dq
    #pragma HLS INTERFACE axis port=kiTs_dq
    #pragma HLS INTERFACE axis port=Eg_d_ref
    #pragma HLS INTERFACE axis port=Eg_q_ref
    #pragma HLS INTERFACE axis port=Eg_zero_ref
    #pragma HLS INTERFACE ap_ctrl_none port=return

    float Ig_d_ref_adapter_out1;
    float Ig_q_ref_adapter_out1;
    float Ig_d_adapter_out1;
    float Ig_q_adapter_out1;
    float Ug_d_adapter_out1;
    float Ug_q_adapter_out1;
    float kp_dq_adapter_out1;
    float kiTs_dq_adapter_out1;
    float XMC_dq_current_ctrl_core_Eg_d_ref;
    float XMC_dq_current_ctrl_core_Eg_q_ref;
    float XMC_dq_current_ctrl_core_Eg_zero_ref;
    xmc::StreamAdapter::readStream(Ig_d_ref, &Ig_d_ref_adapter_out1);
    xmc::StreamAdapter::readStream(Ig_q_ref, &Ig_q_ref_adapter_out1);
    xmc::StreamAdapter::readStream(Ig_d, &Ig_d_adapter_out1);
    xmc::StreamAdapter::readStream(Ig_q, &Ig_q_adapter_out1);
    xmc::StreamAdapter::readStream(Ug_d, &Ug_d_adapter_out1);
    xmc::StreamAdapter::readStream(Ug_q, &Ug_q_adapter_out1);
    xmc::StreamAdapter::readStream(kp_dq, &kp_dq_adapter_out1);
    xmc::StreamAdapter::readStream(kiTs_dq, &kiTs_dq_adapter_out1);
    XMC_dq_current_ctrl_core(Ig_d_ref_adapter_out1, Ig_q_ref_adapter_out1, 
        Ig_d_adapter_out1, Ig_q_adapter_out1, Ug_d_adapter_out1, 
        Ug_q_adapter_out1, kp_dq_adapter_out1, kiTs_dq_adapter_out1, &
        XMC_dq_current_ctrl_core_Eg_d_ref, &XMC_dq_current_ctrl_core_Eg_q_ref, 
        &XMC_dq_current_ctrl_core_Eg_zero_ref);
    xmc::StreamAdapter::writeStream(Eg_d_ref, XMC_dq_current_ctrl_core_Eg_d_ref
        );
    xmc::StreamAdapter::writeStream(Eg_q_ref, XMC_dq_current_ctrl_core_Eg_q_ref
        );
    xmc::StreamAdapter::writeStream(Eg_zero_ref, 
        XMC_dq_current_ctrl_core_Eg_zero_ref);
}


