#include <systemc>
#include <iostream>
#include <cstdlib>
#include <cstddef>
#include <stdint.h>
#include "SysCFileHandler.h"
#include "ap_int.h"
#include "ap_fixed.h"
#include <complex>
#include <stdbool.h>
#include "autopilot_cbe.h"
#include "hls_stream.h"
#include "hls_half.h"
#include "hls_signal_handler.h"

using namespace std;
using namespace sc_core;
using namespace sc_dt;

// wrapc file define:
#define AUTOTB_TVIN_Ig_d_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Ig_d_ref_V.dat"
#define AUTOTB_TVOUT_Ig_d_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Ig_d_ref_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ig_d_ref_V "../tv/stream_size/stream_size_in_Ig_d_ref_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ig_d_ref_V "../tv/stream_size/stream_ingress_status_Ig_d_ref_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_q_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Ig_q_ref_V.dat"
#define AUTOTB_TVOUT_Ig_q_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Ig_q_ref_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ig_q_ref_V "../tv/stream_size/stream_size_in_Ig_q_ref_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ig_q_ref_V "../tv/stream_size/stream_ingress_status_Ig_q_ref_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_d_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Ig_d_V.dat"
#define AUTOTB_TVOUT_Ig_d_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Ig_d_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ig_d_V "../tv/stream_size/stream_size_in_Ig_d_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ig_d_V "../tv/stream_size/stream_ingress_status_Ig_d_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ig_q_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Ig_q_V.dat"
#define AUTOTB_TVOUT_Ig_q_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Ig_q_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ig_q_V "../tv/stream_size/stream_size_in_Ig_q_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ig_q_V "../tv/stream_size/stream_ingress_status_Ig_q_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_d_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Ug_d_V.dat"
#define AUTOTB_TVOUT_Ug_d_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Ug_d_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ug_d_V "../tv/stream_size/stream_size_in_Ug_d_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ug_d_V "../tv/stream_size/stream_ingress_status_Ug_d_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Ug_q_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Ug_q_V.dat"
#define AUTOTB_TVOUT_Ug_q_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Ug_q_V.dat"
#define WRAPC_STREAM_SIZE_IN_Ug_q_V "../tv/stream_size/stream_size_in_Ug_q_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_Ug_q_V "../tv/stream_size/stream_ingress_status_Ug_q_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_kp_dq_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_kp_dq_V.dat"
#define AUTOTB_TVOUT_kp_dq_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_kp_dq_V.dat"
#define WRAPC_STREAM_SIZE_IN_kp_dq_V "../tv/stream_size/stream_size_in_kp_dq_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_kp_dq_V "../tv/stream_size/stream_ingress_status_kp_dq_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_kiTs_dq_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_kiTs_dq_V.dat"
#define AUTOTB_TVOUT_kiTs_dq_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_kiTs_dq_V.dat"
#define WRAPC_STREAM_SIZE_IN_kiTs_dq_V "../tv/stream_size/stream_size_in_kiTs_dq_V.dat"
#define WRAPC_STREAM_INGRESS_STATUS_kiTs_dq_V "../tv/stream_size/stream_ingress_status_kiTs_dq_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Eg_d_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Eg_d_ref_V.dat"
#define AUTOTB_TVOUT_Eg_d_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Eg_d_ref_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Eg_d_ref_V "../tv/stream_size/stream_size_out_Eg_d_ref_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Eg_d_ref_V "../tv/stream_size/stream_egress_status_Eg_d_ref_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Eg_q_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Eg_q_ref_V.dat"
#define AUTOTB_TVOUT_Eg_q_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Eg_q_ref_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Eg_q_ref_V "../tv/stream_size/stream_size_out_Eg_q_ref_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Eg_q_ref_V "../tv/stream_size/stream_egress_status_Eg_q_ref_V.dat"
// wrapc file define:
#define AUTOTB_TVIN_Eg_zero_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvin_Eg_zero_ref_V.dat"
#define AUTOTB_TVOUT_Eg_zero_ref_V "../tv/cdatafile/c.XMC_dq_current_ctrl.autotvout_Eg_zero_ref_V.dat"
#define WRAPC_STREAM_SIZE_OUT_Eg_zero_ref_V "../tv/stream_size/stream_size_out_Eg_zero_ref_V.dat"
#define WRAPC_STREAM_EGRESS_STATUS_Eg_zero_ref_V "../tv/stream_size/stream_egress_status_Eg_zero_ref_V.dat"

#define INTER_TCL "../tv/cdatafile/ref.tcl"

// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_d_ref_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Ig_d_ref_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_q_ref_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Ig_q_ref_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_d_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Ig_d_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ig_q_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Ig_q_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_d_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Ug_d_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Ug_q_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Ug_q_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_kp_dq_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_kp_dq_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_kiTs_dq_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_kiTs_dq_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Eg_d_ref_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Eg_d_ref_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Eg_q_ref_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Eg_q_ref_V.dat"
// tvout file define:
#define AUTOTB_TVOUT_PC_Eg_zero_ref_V "../tv/rtldatafile/rtl.XMC_dq_current_ctrl.autotvout_Eg_zero_ref_V.dat"

class INTER_TCL_FILE {
  public:
INTER_TCL_FILE(const char* name) {
  mName = name; 
  Ig_d_ref_V_depth = 0;
  Ig_q_ref_V_depth = 0;
  Ig_d_V_depth = 0;
  Ig_q_V_depth = 0;
  Ug_d_V_depth = 0;
  Ug_q_V_depth = 0;
  kp_dq_V_depth = 0;
  kiTs_dq_V_depth = 0;
  Eg_d_ref_V_depth = 0;
  Eg_q_ref_V_depth = 0;
  Eg_zero_ref_V_depth = 0;
  trans_num =0;
}
~INTER_TCL_FILE() {
  mFile.open(mName);
  if (!mFile.good()) {
    cout << "Failed to open file ref.tcl" << endl;
    exit (1); 
  }
  string total_list = get_depth_list();
  mFile << "set depth_list {\n";
  mFile << total_list;
  mFile << "}\n";
  mFile << "set trans_num "<<trans_num<<endl;
  mFile.close();
}
string get_depth_list () {
  stringstream total_list;
  total_list << "{Ig_d_ref_V " << Ig_d_ref_V_depth << "}\n";
  total_list << "{Ig_q_ref_V " << Ig_q_ref_V_depth << "}\n";
  total_list << "{Ig_d_V " << Ig_d_V_depth << "}\n";
  total_list << "{Ig_q_V " << Ig_q_V_depth << "}\n";
  total_list << "{Ug_d_V " << Ug_d_V_depth << "}\n";
  total_list << "{Ug_q_V " << Ug_q_V_depth << "}\n";
  total_list << "{kp_dq_V " << kp_dq_V_depth << "}\n";
  total_list << "{kiTs_dq_V " << kiTs_dq_V_depth << "}\n";
  total_list << "{Eg_d_ref_V " << Eg_d_ref_V_depth << "}\n";
  total_list << "{Eg_q_ref_V " << Eg_q_ref_V_depth << "}\n";
  total_list << "{Eg_zero_ref_V " << Eg_zero_ref_V_depth << "}\n";
  return total_list.str();
}
void set_num (int num , int* class_num) {
  (*class_num) = (*class_num) > num ? (*class_num) : num;
}
void set_string(std::string list, std::string* class_list) {
  (*class_list) = list;
}
  public:
    int Ig_d_ref_V_depth;
    int Ig_q_ref_V_depth;
    int Ig_d_V_depth;
    int Ig_q_V_depth;
    int Ug_d_V_depth;
    int Ug_q_V_depth;
    int kp_dq_V_depth;
    int kiTs_dq_V_depth;
    int Eg_d_ref_V_depth;
    int Eg_q_ref_V_depth;
    int Eg_zero_ref_V_depth;
    int trans_num;
  private:
    ofstream mFile;
    const char* mName;
};

static void RTLOutputCheckAndReplacement(std::string &AESL_token, std::string PortName) {
  bool no_x = false;
  bool err = false;

  no_x = false;
  // search and replace 'X' with '0' from the 3rd char of token
  while (!no_x) {
    size_t x_found = AESL_token.find('X', 0);
    if (x_found != string::npos) {
      if (!err) { 
        cerr << "WARNING: [SIM 212-201] RTL produces unknown value 'X' on port" 
             << PortName << ", possible cause: There are uninitialized variables in the C design."
             << endl; 
        err = true;
      }
      AESL_token.replace(x_found, 1, "0");
    } else
      no_x = true;
  }
  no_x = false;
  // search and replace 'x' with '0' from the 3rd char of token
  while (!no_x) {
    size_t x_found = AESL_token.find('x', 2);
    if (x_found != string::npos) {
      if (!err) { 
        cerr << "WARNING: [SIM 212-201] RTL produces unknown value 'x' on port" 
             << PortName << ", possible cause: There are uninitialized variables in the C design."
             << endl; 
        err = true;
      }
      AESL_token.replace(x_found, 1, "0");
    } else
      no_x = true;
  }
}
extern "C" void XMC_dq_current_ctrl_hw_stub_wrapper(volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *, volatile void *);

extern "C" void apatb_XMC_dq_current_ctrl_hw(volatile void * __xlx_apatb_param_Ig_d_ref, volatile void * __xlx_apatb_param_Ig_q_ref, volatile void * __xlx_apatb_param_Ig_d, volatile void * __xlx_apatb_param_Ig_q, volatile void * __xlx_apatb_param_Ug_d, volatile void * __xlx_apatb_param_Ug_q, volatile void * __xlx_apatb_param_kp_dq, volatile void * __xlx_apatb_param_kiTs_dq, volatile void * __xlx_apatb_param_Eg_d_ref, volatile void * __xlx_apatb_param_Eg_q_ref, volatile void * __xlx_apatb_param_Eg_zero_ref) {
  refine_signal_handler();
  fstream wrapc_switch_file_token;
  wrapc_switch_file_token.open(".hls_cosim_wrapc_switch.log");
  int AESL_i;
  if (wrapc_switch_file_token.good())
  {

    CodeState = ENTER_WRAPC_PC;
    static unsigned AESL_transaction_pc = 0;
    string AESL_token;
    string AESL_num;long __xlx_apatb_param_Ig_d_ref_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ig_d_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_d_ref_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ig_d_ref_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ig_d_ref)->read();
long __xlx_apatb_param_Ig_q_ref_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ig_q_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_q_ref_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ig_q_ref_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ig_q_ref)->read();
long __xlx_apatb_param_Ig_d_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ig_d_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_d_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ig_d_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ig_d)->read();
long __xlx_apatb_param_Ig_q_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ig_q_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ig_q_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ig_q_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ig_q)->read();
long __xlx_apatb_param_Ug_d_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ug_d_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_d_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ug_d_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ug_d)->read();
long __xlx_apatb_param_Ug_q_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_Ug_q_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Ug_q_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_Ug_q_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_Ug_q)->read();
long __xlx_apatb_param_kp_dq_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_kp_dq_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_kp_dq_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_kp_dq_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_kp_dq)->read();
long __xlx_apatb_param_kiTs_dq_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_IN_kiTs_dq_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_kiTs_dq_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  for (long i = 0; i < __xlx_apatb_param_kiTs_dq_V_stream_buf_final_size; ++i)((hls::stream<float>*)__xlx_apatb_param_kiTs_dq)->read();
long __xlx_apatb_param_Eg_d_ref_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Eg_d_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Eg_d_ref_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Eg_d_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Eg_d_ref_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Eg_d_ref_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Eg_d_ref_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Eg_d_ref_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Eg_d_ref)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_Eg_q_ref_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Eg_q_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Eg_q_ref_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Eg_q_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Eg_q_ref_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Eg_q_ref_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Eg_q_ref_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Eg_q_ref_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Eg_q_ref)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  long __xlx_apatb_param_Eg_zero_ref_V_stream_buf_final_size;
{
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(WRAPC_STREAM_SIZE_OUT_Eg_zero_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){__xlx_apatb_param_Eg_zero_ref_V_stream_buf_final_size = atoi(AESL_token.c_str());

            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  {
      static ifstream rtl_tv_out_file;
      if (!rtl_tv_out_file.is_open()) {
        rtl_tv_out_file.open(AUTOTB_TVOUT_PC_Eg_zero_ref_V);
        if (rtl_tv_out_file.good()) {
          rtl_tv_out_file >> AESL_token;
          if (AESL_token != "[[[runtime]]]")
            exit(1);
        }
      }
  
      if (rtl_tv_out_file.good()) {
        rtl_tv_out_file >> AESL_token; 
        rtl_tv_out_file >> AESL_num;  // transaction number
        if (AESL_token != "[[transaction]]") {
          cerr << "Unexpected token: " << AESL_token << endl;
          exit(1);
        }
        if (atoi(AESL_num.c_str()) == AESL_transaction_pc) {
          std::vector<sc_bv<32> > Eg_zero_ref_V_pc_buffer;
          int i = 0;

          rtl_tv_out_file >> AESL_token; //data
          while (AESL_token != "[[/transaction]]"){

            RTLOutputCheckAndReplacement(AESL_token, "Eg_zero_ref_V");
  
            // push token into output port buffer
            if (AESL_token != "") {
              Eg_zero_ref_V_pc_buffer.push_back(AESL_token.c_str());
              i++;
            }
  
            rtl_tv_out_file >> AESL_token; //data or [[/transaction]]
            if (AESL_token == "[[[/runtime]]]" || rtl_tv_out_file.eof())
              exit(1);
          }
          if (i > 0) {for (int j = 0, e = i; j != e; ++j) {
float xlx_stream_elt;

            ((int*)&xlx_stream_elt)[0] = Eg_zero_ref_V_pc_buffer[j].to_int64();
          ((hls::stream<float>*)__xlx_apatb_param_Eg_zero_ref)->write(xlx_stream_elt);
}
}
        } // end transaction
      } // end file is good
    } // end post check logic bolck
  
    AESL_transaction_pc++;
    return ;
  }
static unsigned AESL_transaction;
static AESL_FILE_HANDLER aesl_fh;
static INTER_TCL_FILE tcl_file(INTER_TCL);
std::vector<char> __xlx_sprintf_buffer(1024);
CodeState = ENTER_WRAPC;
//Ig_d_ref_V
aesl_fh.touch(AUTOTB_TVIN_Ig_d_ref_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_d_ref_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ig_d_ref_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ig_d_ref_V);
//Ig_q_ref_V
aesl_fh.touch(AUTOTB_TVIN_Ig_q_ref_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_q_ref_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ig_q_ref_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ig_q_ref_V);
//Ig_d_V
aesl_fh.touch(AUTOTB_TVIN_Ig_d_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_d_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ig_d_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ig_d_V);
//Ig_q_V
aesl_fh.touch(AUTOTB_TVIN_Ig_q_V);
aesl_fh.touch(AUTOTB_TVOUT_Ig_q_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ig_q_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ig_q_V);
//Ug_d_V
aesl_fh.touch(AUTOTB_TVIN_Ug_d_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_d_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ug_d_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ug_d_V);
//Ug_q_V
aesl_fh.touch(AUTOTB_TVIN_Ug_q_V);
aesl_fh.touch(AUTOTB_TVOUT_Ug_q_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_Ug_q_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_Ug_q_V);
//kp_dq_V
aesl_fh.touch(AUTOTB_TVIN_kp_dq_V);
aesl_fh.touch(AUTOTB_TVOUT_kp_dq_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_kp_dq_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_kp_dq_V);
//kiTs_dq_V
aesl_fh.touch(AUTOTB_TVIN_kiTs_dq_V);
aesl_fh.touch(AUTOTB_TVOUT_kiTs_dq_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_IN_kiTs_dq_V);
aesl_fh.touch(WRAPC_STREAM_INGRESS_STATUS_kiTs_dq_V);
//Eg_d_ref_V
aesl_fh.touch(AUTOTB_TVIN_Eg_d_ref_V);
aesl_fh.touch(AUTOTB_TVOUT_Eg_d_ref_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Eg_d_ref_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Eg_d_ref_V);
//Eg_q_ref_V
aesl_fh.touch(AUTOTB_TVIN_Eg_q_ref_V);
aesl_fh.touch(AUTOTB_TVOUT_Eg_q_ref_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Eg_q_ref_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Eg_q_ref_V);
//Eg_zero_ref_V
aesl_fh.touch(AUTOTB_TVIN_Eg_zero_ref_V);
aesl_fh.touch(AUTOTB_TVOUT_Eg_zero_ref_V);
aesl_fh.touch(WRAPC_STREAM_SIZE_OUT_Eg_zero_ref_V);
aesl_fh.touch(WRAPC_STREAM_EGRESS_STATUS_Eg_zero_ref_V);
CodeState = DUMP_INPUTS;
std::vector<float> __xlx_apatb_param_Ig_d_ref_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_d_ref)->empty())
    __xlx_apatb_param_Ig_d_ref_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_d_ref)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_d_ref_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_d_ref)->write(__xlx_apatb_param_Ig_d_ref_stream_buf[i]);
  }
long __xlx_apatb_param_Ig_d_ref_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_d_ref)->size();
std::vector<float> __xlx_apatb_param_Ig_q_ref_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_q_ref)->empty())
    __xlx_apatb_param_Ig_q_ref_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_q_ref)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_q_ref_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_q_ref)->write(__xlx_apatb_param_Ig_q_ref_stream_buf[i]);
  }
long __xlx_apatb_param_Ig_q_ref_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_q_ref)->size();
std::vector<float> __xlx_apatb_param_Ig_d_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_d)->empty())
    __xlx_apatb_param_Ig_d_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_d)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_d_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_d)->write(__xlx_apatb_param_Ig_d_stream_buf[i]);
  }
long __xlx_apatb_param_Ig_d_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_d)->size();
std::vector<float> __xlx_apatb_param_Ig_q_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ig_q)->empty())
    __xlx_apatb_param_Ig_q_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ig_q)->read());
  for (int i = 0; i < __xlx_apatb_param_Ig_q_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ig_q)->write(__xlx_apatb_param_Ig_q_stream_buf[i]);
  }
long __xlx_apatb_param_Ig_q_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ig_q)->size();
std::vector<float> __xlx_apatb_param_Ug_d_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_d)->empty())
    __xlx_apatb_param_Ug_d_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_d)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_d_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_d)->write(__xlx_apatb_param_Ug_d_stream_buf[i]);
  }
long __xlx_apatb_param_Ug_d_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_d)->size();
std::vector<float> __xlx_apatb_param_Ug_q_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Ug_q)->empty())
    __xlx_apatb_param_Ug_q_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Ug_q)->read());
  for (int i = 0; i < __xlx_apatb_param_Ug_q_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Ug_q)->write(__xlx_apatb_param_Ug_q_stream_buf[i]);
  }
long __xlx_apatb_param_Ug_q_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Ug_q)->size();
std::vector<float> __xlx_apatb_param_kp_dq_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_kp_dq)->empty())
    __xlx_apatb_param_kp_dq_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_kp_dq)->read());
  for (int i = 0; i < __xlx_apatb_param_kp_dq_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_kp_dq)->write(__xlx_apatb_param_kp_dq_stream_buf[i]);
  }
long __xlx_apatb_param_kp_dq_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_kp_dq)->size();
std::vector<float> __xlx_apatb_param_kiTs_dq_stream_buf;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_kiTs_dq)->empty())
    __xlx_apatb_param_kiTs_dq_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_kiTs_dq)->read());
  for (int i = 0; i < __xlx_apatb_param_kiTs_dq_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_kiTs_dq)->write(__xlx_apatb_param_kiTs_dq_stream_buf[i]);
  }
long __xlx_apatb_param_kiTs_dq_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_kiTs_dq)->size();
std::vector<float> __xlx_apatb_param_Eg_d_ref_stream_buf;
long __xlx_apatb_param_Eg_d_ref_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Eg_d_ref)->size();
std::vector<float> __xlx_apatb_param_Eg_q_ref_stream_buf;
long __xlx_apatb_param_Eg_q_ref_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Eg_q_ref)->size();
std::vector<float> __xlx_apatb_param_Eg_zero_ref_stream_buf;
long __xlx_apatb_param_Eg_zero_ref_stream_buf_size = ((hls::stream<float>*)__xlx_apatb_param_Eg_zero_ref)->size();
CodeState = CALL_C_DUT;
XMC_dq_current_ctrl_hw_stub_wrapper(__xlx_apatb_param_Ig_d_ref, __xlx_apatb_param_Ig_q_ref, __xlx_apatb_param_Ig_d, __xlx_apatb_param_Ig_q, __xlx_apatb_param_Ug_d, __xlx_apatb_param_Ug_q, __xlx_apatb_param_kp_dq, __xlx_apatb_param_kiTs_dq, __xlx_apatb_param_Eg_d_ref, __xlx_apatb_param_Eg_q_ref, __xlx_apatb_param_Eg_zero_ref);
CodeState = DUMP_OUTPUTS;
long __xlx_apatb_param_Ig_d_ref_stream_buf_final_size = __xlx_apatb_param_Ig_d_ref_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ig_d_ref)->size();
// print Ig_d_ref_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ig_d_ref_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_d_ref_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_d_ref_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ig_d_ref_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_d_ref_stream_buf_final_size, &tcl_file.Ig_d_ref_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ig_d_ref_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_ref_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ig_d_ref_stream_buf_final_size > 0) {
  long Ig_d_ref_V_stream_ingress_size = __xlx_apatb_param_Ig_d_ref_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_d_ref_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_ref_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_d_ref_stream_buf_final_size; j != e; j++) {
    Ig_d_ref_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_d_ref_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_ref_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ig_d_ref_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_d_ref_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_ref_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_ref_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_d_ref_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_d_ref_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_d_ref_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_d_ref_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_q_ref_stream_buf_final_size = __xlx_apatb_param_Ig_q_ref_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ig_q_ref)->size();
// print Ig_q_ref_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ig_q_ref_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_q_ref_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_q_ref_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ig_q_ref_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_q_ref_stream_buf_final_size, &tcl_file.Ig_q_ref_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ig_q_ref_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_ref_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ig_q_ref_stream_buf_final_size > 0) {
  long Ig_q_ref_V_stream_ingress_size = __xlx_apatb_param_Ig_q_ref_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_q_ref_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_ref_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_q_ref_stream_buf_final_size; j != e; j++) {
    Ig_q_ref_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_q_ref_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_ref_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ig_q_ref_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_q_ref_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_ref_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_ref_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_q_ref_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_q_ref_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_q_ref_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_q_ref_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_d_stream_buf_final_size = __xlx_apatb_param_Ig_d_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ig_d)->size();
// print Ig_d_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ig_d_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_d_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_d_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ig_d_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_d_stream_buf_final_size, &tcl_file.Ig_d_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ig_d_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ig_d_stream_buf_final_size > 0) {
  long Ig_d_V_stream_ingress_size = __xlx_apatb_param_Ig_d_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_d_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_d_stream_buf_final_size; j != e; j++) {
    Ig_d_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_d_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ig_d_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_d_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_d_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_d_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_d_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_d_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_d_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ig_q_stream_buf_final_size = __xlx_apatb_param_Ig_q_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ig_q)->size();
// print Ig_q_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ig_q_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_q_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ig_q_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ig_q_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ig_q_stream_buf_final_size, &tcl_file.Ig_q_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ig_q_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ig_q_stream_buf_final_size > 0) {
  long Ig_q_V_stream_ingress_size = __xlx_apatb_param_Ig_q_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_q_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ig_q_stream_buf_final_size; j != e; j++) {
    Ig_q_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_q_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ig_q_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ig_q_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ig_q_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_q_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ig_q_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_q_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ig_q_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_d_stream_buf_final_size = __xlx_apatb_param_Ug_d_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ug_d)->size();
// print Ug_d_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ug_d_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_d_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_d_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ug_d_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_d_stream_buf_final_size, &tcl_file.Ug_d_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ug_d_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_d_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ug_d_stream_buf_final_size > 0) {
  long Ug_d_V_stream_ingress_size = __xlx_apatb_param_Ug_d_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_d_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_d_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_d_stream_buf_final_size; j != e; j++) {
    Ug_d_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_d_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_d_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ug_d_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_d_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_d_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_d_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_d_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_d_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_d_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_d_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Ug_q_stream_buf_final_size = __xlx_apatb_param_Ug_q_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_Ug_q)->size();
// print Ug_q_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_Ug_q_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_q_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_Ug_q_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_Ug_q_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Ug_q_stream_buf_final_size, &tcl_file.Ug_q_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_Ug_q_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_q_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_Ug_q_stream_buf_final_size > 0) {
  long Ug_q_V_stream_ingress_size = __xlx_apatb_param_Ug_q_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_q_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_q_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Ug_q_stream_buf_final_size; j != e; j++) {
    Ug_q_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_q_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_q_V, __xlx_sprintf_buffer.data());
  }
} else {
  long Ug_q_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", Ug_q_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_q_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_Ug_q_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_q_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Ug_q_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_q_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_Ug_q_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_kp_dq_stream_buf_final_size = __xlx_apatb_param_kp_dq_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_kp_dq)->size();
// print kp_dq_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_kp_dq_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_kp_dq_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_kp_dq_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_kp_dq_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_kp_dq_stream_buf_final_size, &tcl_file.kp_dq_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_kp_dq_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kp_dq_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_kp_dq_stream_buf_final_size > 0) {
  long kp_dq_V_stream_ingress_size = __xlx_apatb_param_kp_dq_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", kp_dq_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kp_dq_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_kp_dq_stream_buf_final_size; j != e; j++) {
    kp_dq_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", kp_dq_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kp_dq_V, __xlx_sprintf_buffer.data());
  }
} else {
  long kp_dq_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", kp_dq_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kp_dq_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kp_dq_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_kp_dq_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_kp_dq_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_kp_dq_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_kp_dq_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_kiTs_dq_stream_buf_final_size = __xlx_apatb_param_kiTs_dq_stream_buf_size - ((hls::stream<float>*)__xlx_apatb_param_kiTs_dq)->size();
// print kiTs_dq_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVIN_kiTs_dq_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_kiTs_dq_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv_hw;
sc_bv<32> __xlx_tmp_lv;
__xlx_tmp_lv = ((int*)&__xlx_apatb_param_kiTs_dq_stream_buf[j])[0];
__xlx_tmp_lv_hw = __xlx_tmp_lv;

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv_hw.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVIN_kiTs_dq_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_kiTs_dq_stream_buf_final_size, &tcl_file.kiTs_dq_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVIN_kiTs_dq_V, __xlx_sprintf_buffer.data());
}

// dump stream ingress status to file
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kiTs_dq_V, __xlx_sprintf_buffer.data());
  if (__xlx_apatb_param_kiTs_dq_stream_buf_final_size > 0) {
  long kiTs_dq_V_stream_ingress_size = __xlx_apatb_param_kiTs_dq_stream_buf_size;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", kiTs_dq_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kiTs_dq_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_kiTs_dq_stream_buf_final_size; j != e; j++) {
    kiTs_dq_V_stream_ingress_size--;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", kiTs_dq_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kiTs_dq_V, __xlx_sprintf_buffer.data());
  }
} else {
  long kiTs_dq_V_stream_ingress_size = 0;
sprintf(__xlx_sprintf_buffer.data(), "%d\n", kiTs_dq_V_stream_ingress_size);
 aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kiTs_dq_V, __xlx_sprintf_buffer.data());
}

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_INGRESS_STATUS_kiTs_dq_V, __xlx_sprintf_buffer.data());
}{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_kiTs_dq_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_kiTs_dq_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_IN_kiTs_dq_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_IN_kiTs_dq_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Eg_d_ref_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Eg_d_ref)->size() - __xlx_apatb_param_Eg_d_ref_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Eg_d_ref)->empty())
    __xlx_apatb_param_Eg_d_ref_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Eg_d_ref)->read());
  for (int i = 0; i < __xlx_apatb_param_Eg_d_ref_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Eg_d_ref)->write(__xlx_apatb_param_Eg_d_ref_stream_buf[i]);
  }
// print Eg_d_ref_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Eg_d_ref_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Eg_d_ref_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Eg_d_ref_stream_buf[__xlx_apatb_param_Eg_d_ref_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Eg_d_ref_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Eg_d_ref_stream_buf_final_size, &tcl_file.Eg_d_ref_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Eg_d_ref_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_d_ref_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Eg_d_ref_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_d_ref_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_d_ref_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Eg_q_ref_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Eg_q_ref)->size() - __xlx_apatb_param_Eg_q_ref_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Eg_q_ref)->empty())
    __xlx_apatb_param_Eg_q_ref_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Eg_q_ref)->read());
  for (int i = 0; i < __xlx_apatb_param_Eg_q_ref_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Eg_q_ref)->write(__xlx_apatb_param_Eg_q_ref_stream_buf[i]);
  }
// print Eg_q_ref_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Eg_q_ref_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Eg_q_ref_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Eg_q_ref_stream_buf[__xlx_apatb_param_Eg_q_ref_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Eg_q_ref_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Eg_q_ref_stream_buf_final_size, &tcl_file.Eg_q_ref_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Eg_q_ref_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_q_ref_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Eg_q_ref_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_q_ref_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_q_ref_V, __xlx_sprintf_buffer.data());
}long __xlx_apatb_param_Eg_zero_ref_stream_buf_final_size = ((hls::stream<float>*)__xlx_apatb_param_Eg_zero_ref)->size() - __xlx_apatb_param_Eg_zero_ref_stream_buf_size;
{
  while (!((hls::stream<float>*)__xlx_apatb_param_Eg_zero_ref)->empty())
    __xlx_apatb_param_Eg_zero_ref_stream_buf.push_back(((hls::stream<float>*)__xlx_apatb_param_Eg_zero_ref)->read());
  for (int i = 0; i < __xlx_apatb_param_Eg_zero_ref_stream_buf.size(); ++i)
    ((hls::stream<float>*)__xlx_apatb_param_Eg_zero_ref)->write(__xlx_apatb_param_Eg_zero_ref_stream_buf[i]);
  }
// print Eg_zero_ref_V Transactions
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(AUTOTB_TVOUT_Eg_zero_ref_V, __xlx_sprintf_buffer.data());
  for (int j = 0, e = __xlx_apatb_param_Eg_zero_ref_stream_buf_final_size; j != e; ++j) {
sc_bv<32> __xlx_tmp_lv = ((int*)&__xlx_apatb_param_Eg_zero_ref_stream_buf[__xlx_apatb_param_Eg_zero_ref_stream_buf_size+j])[0];

    sprintf(__xlx_sprintf_buffer.data(), "%s\n", __xlx_tmp_lv.to_string(SC_HEX).c_str());
    aesl_fh.write(AUTOTB_TVOUT_Eg_zero_ref_V, __xlx_sprintf_buffer.data()); 
  }

  tcl_file.set_num(__xlx_apatb_param_Eg_zero_ref_stream_buf_final_size, &tcl_file.Eg_zero_ref_V_depth);
  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(AUTOTB_TVOUT_Eg_zero_ref_V, __xlx_sprintf_buffer.data());
}
{
  sprintf(__xlx_sprintf_buffer.data(), "[[transaction]] %d\n", AESL_transaction);
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_zero_ref_V, __xlx_sprintf_buffer.data());
  sprintf(__xlx_sprintf_buffer.data(), "%d\n", __xlx_apatb_param_Eg_zero_ref_stream_buf_final_size);
 aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_zero_ref_V, __xlx_sprintf_buffer.data());

  sprintf(__xlx_sprintf_buffer.data(), "[[/transaction]] \n");
  aesl_fh.write(WRAPC_STREAM_SIZE_OUT_Eg_zero_ref_V, __xlx_sprintf_buffer.data());
}CodeState = DELETE_CHAR_BUFFERS;
AESL_transaction++;
tcl_file.set_num(AESL_transaction , &tcl_file.trans_num);
}
