# ==============================================================
# File generated by Xilinx Model Composer(TM)
# Version: 2020.2
#  
# (c) Copyright 2017 - 2020 Xilinx, Inc. All rights reserved.
#  
# This file contains confidential and proprietary information
# of Xilinx, Inc. and is protected under U.S. and
# international copyright and other intellectual property
# laws.
#  
# DISCLAIMER
# This disclaimer is not a license and does not grant any
# rights to the materials distributed herewith. Except as
# otherwise provided in a valid license issued to you by
# Xilinx, and to the maximum extent permitted by applicable
# law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
# WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
# AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
# BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
# INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
# (2) Xilinx shall not be liable (whether in contract or tort,
# including negligence, or under any other theory of
# liability) for any loss or damage of any kind or nature
# related to, arising under or in connection with these
# materials, including for any direct, or any indirect,
# special, incidental, or consequential loss or damage
# (including loss of data, profits, goodwill, or any type of
# loss or damage suffered as a result of any action brought
# by a third party) even if such damage or loss was
# reasonably foreseeable or Xilinx had been advised of the
# possibility of the same.
#  
# CRITICAL APPLICATIONS
# Xilinx products are not designed or intended to be fail-
# safe, or for use in any application requiring fail-safe
# performance, such as life-support or safety devices or
# systems, Class III medical devices, nuclear facilities,
# applications related to the deployment of airbags, or any
# other applications that could lead to death, personal
# injury, or severe property or environmental damage
# (individually and collectively, "Critical
# Applications"). Customer assumes the sole risk and
# liability of any use of Xilinx products in Critical
# Applications, subject only to applicable laws and
# regulations governing limitations on product liability.
#  
# THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
# PART OF THIS FILE AT ALL TIMES.
# ==============================================================
##################################################
# Project settings
set disable_auto_rewind 0
set enable_csim 1
set enable_cosim 1
set enable_cosim_deadlock_detection 1
set enable_export_to_ip_catalog 1
set enable_export_to_sysgen 0
set has_tb 0

# Webtalk data
common::set_param hls.webtalk.field2 "model_composer"

# Change to the code generation directory
cd {D:/Vivado_workspace/KnowledgeBase/fpga_ips/xmc_dq_current_ctrl}

# Create a project
open_project -reset XMC_dq_current_ctrl_prj

# Specify cflags
set cflags { -O3 -ffloat-store -Wno-attributes -fno-tree-vectorize }
append cflags { -ID:/Xilinx/Model_Composer/2020.2/include/tb}


# Specify linker flags
set ldflags {}
append ldflags { -Wl,--stack,10485760}


# Specify source files
add_files {XMC_dq_current_ctrl.cpp} -cflags $cflags
add_files {XMC_dq_current_ctrl.h}


# Specify test bench files


# Specify the top-level function for synthesis
set_top XMC_dq_current_ctrl

##################################################
# Solution 1
##################################################
open_solution -reset solution1

# disable auto-rewind optimisation
if { $disable_auto_rewind } {
  set_param hls.enable_loop_extract false
  set_param hls.unified_pipeline_control false
}


# Specify a Xilinx device and clock period
# - Do not specify a clock uncertainty (margin)
# - Let the margin to default to 12.5% of clock period
set_part {xc7z030fbg676-3}
create_clock -period 4.000000

# Specify control options
config_rtl -module_auto_prefix=0


# Simulate the C code
# Missing because test bench creation was not enabled

# Synthesize
csynth_design

# Simulate the RTL
# Missing because test bench creation was not enabled


# Export to ip_catalog
if {$enable_export_to_ip_catalog == 1} {
  # Configure options for export_design 
  config_export -vendor xilinx.com -library hls -ipname XMC_dq_current_ctrl -version 1.0 -rtl vhdl

  export_design -format ip_catalog
}

# Export to sysgen
if {$enable_export_to_sysgen == 1} {
  export_design -format sysgen
}

exit
